// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gOverlayCompose = {
  _composeIt: null,
  
  contextMenuShowing: function()
  {
    var show = GM_getGlobal().getBoolValue("compose-context-menu");
    
    if (show && GM_getGlobal().getBoolValue("compose-context-menu-mailto"))
      show = (this._composeIt != null);
    
    GM_getEBI("gm-overlay-context-menu").hidden = !show;
    GM_getEBI("gm-overlay-context-menu").collapsed = !show;
    
    GM_getEBI("gm-overlay-context-sep").hidden = !show;
    GM_getEBI("gm-overlay-context-sep").collapsed = !show;
  },
  
  contextMenuPopulate: function()
  {
    var popup = GM_getEBI("gm-overlay-context-menu-popup");
    var accounts = GM_gOverlay._accounts;
    var current = null;
    var item = null;
    
    // Remove list items
    while (popup.hasChildNodes())
      popup.removeChild(popup.lastChild);
    
    item = document.createElement("menuitem");
    item.setAttribute("label", GM_getBundleString("default-mail-client"));
    item.setAttribute("oncommand", "GM_gOverlayCompose._defaultClick();");
    popup.appendChild(item);
    
    popup.appendChild(document.createElement("menuseparator"));
    
    for (var email in accounts)
    {
      item = document.createElement("menuitem");
      item.setAttribute("label", email);
      item.setAttribute("default", (email == current));
      item.setAttribute("oncommand", "GM_gOverlayCompose._menuClick(event, this.label);");
      popup.appendChild(item);
    }
    
    if (popup.childNodes.length == 2)
    {
      item = document.createElement("menuitem");
      item.setAttribute("label", GM_getBundleString("click-add-account"));
      item.setAttribute("oncommand", "window.openDialog('chrome://gmanager/content/accounts.xul', 'accounts', 'chrome,dependent=yes', 'add');");
      popup.appendChild(item);
    }
  },
  
  _defaultClick: function()
  {
    GM_loadDefaultMail(this._composeIt);
  },
  
  _menuClick: function(aEvent, aEmail)
  {
    GM_loadGmailPage("compose", GM_gOverlay._accounts[aEmail], null, this._composeIt);
  },
  
  linkClick: function(aEvent)
  {
    var linkStr = null;
    var host = null;
    
    // Clear compose object
    this._composeIt = null;
    
    try {
      host = getBrowser().currentURI.host;
    } catch(e) {
      this.contextMenuShowing();
      return contentAreaClick(aEvent, null);
    }
    
    try {
      var tag = aEvent.target;
      while (tag.tagName && tag.tagName.toUpperCase() != "HTML" && linkStr == null)
      {
        if (tag.tagName.toUpperCase() == "A")
          linkStr = tag.getAttribute("HREF");
        tag = tag.parentNode;
      }
    } catch(e) {
      linkStr = null;
    }
    
    // Checks for a mailto link
    if (linkStr && linkStr.indexOf("mailto:") == 0)
    {
      // Reformat the mailto link
      var link = linkStr.replace("mailto:", "").replace("subject=", "su=").replace(/ /ig, "%20");
      var split = link.split("?");
      var send = "&to=" + split[0];
      
      if (split[1] != null)
        send += "&" + split[1];
      
      this._composeIt = new Object;
      this._composeIt.orig = linkStr;
      this._composeIt.fmtd = send;
    }
    
    if (aEvent && (aEvent.button == 0 || aEvent.button == 1) && 
        (this._composeIt != null) &&
        GM_getGlobal().getBoolValue("compose-mailto-links"))
    {
      // Select compose option
      GM_gOverlay.selectOption(aEvent, "compose", this._composeIt);
      
      return false;
    }
    else
      this.contextMenuShowing();
    
    return contentAreaClick(aEvent, null);
  }
}